Contiki-NG up to 4.5 RPL-Classic/RPL-Lite rpl-ext-header.c rpl_ext_header_srh_update addr_ptr out-of-bounds write

EntryeditHistoryDiffjsonxmlCTI
CVSS Meta Temp Score
CVSS is a standardized scoring system to determine possibilities of attacks. The Temp Score considers temporal factors like disclosure, exploit and countermeasures. The unique Meta Score calculates the average score of different sources to provide a normalized scoring system.
Current Exploit Price (≈)
Our analysts are monitoring exploit markets and are in contact with vulnerability brokers. The range indicates the observed or calculated exploit price to be seen on exploit markets. A good indicator to understand the monetary effort required for and the popularity of an attack.
CTI Interest Score
Our Cyber Threat Intelligence team is monitoring different web sites, mailing lists, exploit markets and social media networks. The CTI Interest Score identifies the interest of attackers and the security community for this specific vulnerability in real-time. A high score indicates an elevated risk to be targeted for this vulnerability.
7.0$0-$5k0.06

A vulnerability was found in Contiki-NG up to 4.5. It has been rated as critical. Affected by this issue is the function rpl_ext_header_srh_update of the file rpl-ext-header.c of the component RPL-Classic/RPL-Lite. The manipulation of the argument addr_ptr with an unknown input leads to a memory corruption vulnerability. Using CWE to declare the problem leads to CWE-787. Impacted is confidentiality, integrity, and availability. CVE summarizes:

Contiki-NG is an open-source, cross-platform operating system for internet of things devices. The RPL-Classic and RPL-Lite implementations in the Contiki-NG operating system versions prior to 4.6 do not validate the address pointer in the RPL source routing header This makes it possible for an attacker to cause out-of-bounds writes with packets injected into the network stack. Specifically, the problem lies in the rpl_ext_header_srh_update function in the two rpl-ext-header.c modules for RPL-Classic and RPL-Lite respectively. The addr_ptr variable is calculated using an unvalidated CMPR field value from the source routing header. An out-of-bounds write can be triggered on line 151 in os/net/routing/rpl-lite/rpl-ext-header.c and line 261 in os/net/routing/rpl-classic/rpl-ext-header.c, which contain the following memcpy call with addr_ptr as destination. The problem has been patched in Contiki-NG 4.6. Users can apply a patch out-of-band as a workaround.

The weakness was released 06/19/2021. The advisory is shared for download at github.com. This vulnerability is handled as CVE-2021-21257 since 12/22/2020. The exploitation is known to be easy. The attack may be launched remotely. No form of authentication is required for exploitation. There are known technical details, but no exploit is available.

Upgrading to version 4.6 eliminates this vulnerability. Applying a patch is able to eliminate this problem. The bugfix is ready for download at github.com. The best possible mitigation is suggested to be upgrading to the latest version.

Productinfoedit

Name

CPE 2.3infoedit

CPE 2.2infoedit

CVSSv3infoedit

VulDB Meta Base Score: 7.3
VulDB Meta Temp Score: 7.0

VulDB Base Score: 7.3
VulDB Temp Score: 7.0
VulDB Vector: 🔒
VulDB Reliability: 🔍

CVSSv2infoedit

AVACAuCIA
🔍🔍🔍🔍🔍🔍
🔍🔍🔍🔍🔍🔍
🔍🔍🔍🔍🔍🔍
VectorComplexityAuthenticationConfidentialityIntegrityAvailability
unlockunlockunlockunlockunlockunlock
unlockunlockunlockunlockunlockunlock
unlockunlockunlockunlockunlockunlock

VulDB Base Score: 🔒
VulDB Temp Score: 🔒
VulDB Reliability: 🔍

Exploitinginfoedit

Class: Memory corruption
CWE: CWE-787
ATT&CK: Unknown

Local: No
Remote: Yes

Availability: 🔒
Status: Not defined

Price Prediction: 🔍
Current Price Estimation: 🔒

0-Dayunlockunlockunlockunlock
Todayunlockunlockunlockunlock

Threat Intelligenceinfoedit

Interest: 🔍
Active Actors: 🔍
Active APT Groups: 🔍

Countermeasuresinfoedit

Recommended: Upgrade
Status: 🔍

0-Day Time: 🔒

Upgrade: Contiki-NG 4.6
Patch: github.com

Timelineinfoedit

12/22/2020 CVE assigned
06/19/2021 +178 days Advisory disclosed
06/19/2021 +0 days VulDB entry created
06/21/2021 +2 days VulDB last update

Sourcesinfoedit

Advisory: github.com
Status: Confirmed
Confirmation: 🔒

CVE: CVE-2021-21257 (🔒)

Entryinfoedit

Created: 06/19/2021 07:55 AM
Updated: 06/21/2021 04:32 PM
Changes: (1) source_cve_cna
Complete: 🔍

Comments

No comments yet. Please log in to comment.

Do you want to use VulDB in your project?

Use the official API to access entries easily!